#include "rtos.h"

static void task_y1_z0(void) {}
static void task_y2_z0(void) {}
static void task_y3_z0(void) {}
static void task_y4_z0(void) {}

static void task_y1_z1(void) {}
static void task_y2_z1(void) {}
static void task_y3_z1(void) {}
static void task_y4_z1(void) {}

static void task_y1_z2(void) {}
static void task_y2_z2(void) {}
static void task_y3_z2(void) {}
static void task_y4_z2(void) {}

#define RT (5000000 / TIMER_QUANTUM)
#define BIW(y,z) ((y + z) | (z << 8) | (y << 16) | (0x7 << 28))

int main(void)
{
    print("======================\n");
    print("overhead main() running\n");
    print("======================\n");

    register_task("y1_z0", task_y1_z0, BIW(1, 0), 0, RT);
    register_task("y2_z0", task_y2_z0, BIW(2, 0), 0, RT);
    register_task("y3_z0", task_y3_z0, BIW(3, 0), 0, RT);
    register_task("y4_z0", task_y4_z0, BIW(4, 0), 0, RT);

    register_task("y1_z1", task_y1_z1, BIW(1, 1), 0, RT);
    register_task("y2_z1", task_y2_z1, BIW(2, 1), 0, RT);
    register_task("y3_z1", task_y3_z1, BIW(3, 1), 0, RT);
    register_task("y4_z1", task_y4_z1, BIW(4, 1), 0, RT);

    register_task("y1_z2", task_y1_z2, BIW(1, 2), 0, RT);
    register_task("y2_z2", task_y2_z2, BIW(2, 2), 0, RT);
    register_task("y3_z2", task_y3_z2, BIW(3, 2), 0, RT);
    register_task("y4_z2", task_y4_z2, BIW(4, 2), 0, RT);

    print("start\n");
    kernel_start();
    return 0;
}
